<script lang="ts">
export default {
  name: 'SurveyTextResults',
  props: {
    data: {
      type: Object,
      required: true,
      default: () => ({}),
    },
  },
  data() {
    return {
      currentText: '',
      currentItemIndex: 0,
      prefersReducedMotion: false,
      observer: null,
      isTyping: false,
    };
  },
  mounted() {
    const mediaQuery = window.matchMedia('(prefers-reduced-motion: reduce)');
    this.prefersReducedMotion = mediaQuery.matches;
    if (!this.prefersReducedMotion) {
      this.initIntersectionObserver();
    }
  },
  beforeDestroy() {
    if (this.observer) {
      this.observer.disconnect();
    }
  },
  methods: {
    initIntersectionObserver() {
      const options = {
        root: null,
        rootMargin: '0px',
        threshold: 0.1,
      };

      this.observer = new IntersectionObserver(this.handleIntersect, options);
      const target = this.$refs.listContainer;
      if (target) {
        this.observer.observe(target);
      }
    },
    handleIntersect(entries) {
      entries.forEach((entry) => {
        if (entry.isIntersecting) {
          this.typeWriterEffect();
          this.observer.disconnect();
        }
      });
    },
    async typeWriterEffect() {
      this.isTyping = true; // Start typing
      let text = this.data.text || '';
      if (this.data.list && this.data.list.items) {
        for (let i = 0; i < this.data.list.items.length; i++) {
          this.currentItemIndex = i;
          text = this.data.list.items[i].text;
          await this.animateText(text);
        }
      } else {
        await this.animateText(text);
      }
      this.isTyping = false; // Stop typing after all done
    },
    async animateText(text) {
      for (let j = 0; j <= text.length; j++) {
        this.currentText = text.slice(0, j);
        await new Promise((resolve) => setTimeout(resolve, 20)); // Adjust speed as needed
      }
    },
  },
};
</script>
<template>
  <article class="text-results">
    <SlpTypography
      v-if="data.header"
      variant="heading5-bold"
      tag="h3"
      class="slp-my-24"
    >
      {{ data.header }}
    </SlpTypography>
    <div v-if="data.list" ref="listContainer" class="list">
      <ol v-if="data.list.type === 'ordered'">
        <li v-for="(item, index) in data.list.items" :key="index">
          <span v-if="prefersReducedMotion || index < currentItemIndex">{{
            item.text
          }}</span>
          <span v-else-if="index === currentItemIndex">{{ currentText }}</span>
        </li>
      </ol>
    </div>
    <div v-else ref="textContainer" class="text">
      <div v-html="$md.render(data.text)" />
    </div>
  </article>
</template>

<style lang="scss" scoped>
.text-results {
  min-height: 150px;

  .text,
  .list {
    font-family: 'GitLab Mono';
  }

  .list {
    font-size: 18px;

    ol {
      list-style: auto;
      padding-left: 2.1em;
    }

    li {
      margin-bottom: 16px;
    }
  }

  .text:deep {
    p {
      margin-bottom: 16px;
    }

    p:last-of-type {
      margin-bottom: 0;
    }
  }
}
</style>
